/**
 * @file		retrieve_py.cpp
 *
 * @date		2014-10-16
 * @author	s.imazu
 * 
 * @date		2015-10-01
 * @version		19.0.0
 *
 * @date		2016-11-17
 * @version		19.1.0
 * @note data_length64bitgɕύXB
 *
 *  Oo"return NULL; " ƂB@"Py_RETURN_NONE;" ͂߁B
 *
 */
#if defined(WIN32) || defined(WIN64)
 #pragma warning(disable:4786)
#endif // WIN32

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern "C" {
#include <Python.h>
  void init_retrieve(); 
};

#if defined(WIN32) || defined(WIN64)
 #define	strncasecmp	_strnicmp
 #define	strcasecmp		_stricmp
 typedef	__int64			int64_t;
#else
 #include <string>
 #if PY_VERSION_HEX <= 0x0204FFFF
   typedef	int			Py_ssize_t;
 #endif
#endif // WIN32

#include "retrieve.h"
#define NAME_LEN (32+1)

const int R_PARAM_TYPE_STRING=1;
const int R_PARAM_TYPE_BYTE=2;
const int R_PARAM_TYPE_SHORT=3;
const int R_PARAM_TYPE_INT=4;
const int R_PARAM_TYPE_FLOAT=5;
const int R_PARAM_TYPE_DOUBLE=6;
const int R_PARAM_TYPE_INT64=7;

static PyObject* RetrieveError;
//
//  PyObject* code_obj = Py_BuildValue("(s,s,i)",func_name", "error message ", code);
//  PyErr_SetObject(RetrieveError, code_obj);
//  Py_DECREF(code_obj);  <-- ??????????????
//  return NULL;
//
//   try:
//
//   except labcom._retrieve.Error, (func, msg,code):    
//

//  ꍇ́ATypeErrorO
//  ̌^Ⴄꍇ́ATypeErrorO

/**
	[֐] version

	<>
		Ȃ

	<Ԓl>
		ver :string	retrievẽo[W

 */
static PyObject*
retrieve_version_py(PyObject* self,  PyObject* args)
{
	PyObject* retVal = Py_BuildValue("s", retrieveVersion());
	return retVal;
}

/**
	[֐] open

	<>
		diag :String
		index_server :String
		shot_number :uint
		sub_shot :ushort
		timeout :int

	<Ԓl>
		rtr_d :int	retrieveLqqij

	<O>
		TypeError, labcom._retrieve.error
 */
static PyObject*
retrieve_open_py(PyObject* self, PyObject* args)
{
	char* diag;
	char* index_server;
	unsigned int shot_number;
	unsigned short sub_shot;
	int timeout;
  
	if ( !PyArg_ParseTuple(args,"ssIHi", &diag, &index_server, &shot_number, &sub_shot, &timeout) ){
		return NULL;
	}

	int rtr_d = retrieveOpenWait(diag, index_server, shot_number, sub_shot, timeout);
	if( 0 > rtr_d ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","OpenWait",  retrieveErrorMessage(rtr_d),  rtr_d);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	}
	PyObject* ret_val = Py_BuildValue("i", rtr_d);
	return ret_val;
}

/**
	[֐] open_range

	<>
		diag :String
		index_server :String
		shot_number :uint
		sub_shot :ushort
		timeout :int
		range_type :int
		range :String

	<Ԓl>
		rtr_d :int	retrieveLqqij

	<O>
		TypeError, labcom._retrieve.error
 */
static PyObject*
retrieve_open_range_py(PyObject* self, PyObject* args)
{
	char* diag;
	char* index_server;
	unsigned int shot_number;
	unsigned short sub_shot;
	int timeout;
	int range_type;
	char* range;
  
	if ( !PyArg_ParseTuple(args,"ssIHiiz", &diag, &index_server, &shot_number, &sub_shot, &timeout, &range_type, &range) ){
		return NULL;
	}

	int rtr_d = retrieveOpenWaitWithRange(diag, index_server, shot_number, sub_shot, timeout, range_type, range);
	if( 0 > rtr_d ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","OpenWaitWithRange",  retrieveErrorMessage(rtr_d),  rtr_d);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	}
	PyObject* ret_val = Py_BuildValue("i", rtr_d);
	return ret_val;
}
/**
	[֐] open_direct

	<>
		diag :String
		server :String
		path :String
		shot_number :uint
		sub_shot :ushort
		port :int
		timeout :int

	<Ԓl>
		rtr_d :int	retrieveLqqij

	<O>
		TypeError, labcom._retrieve.error
 */
static PyObject*
retrieve_open_direct_py(PyObject* self, PyObject* args)
{
	char* diag;
	char* server;
	char* path;
	unsigned int shot_number;
	unsigned short sub_shot;
	int port;
	int timeout;
  
	if ( !PyArg_ParseTuple(args,"sssIHii", &diag, &server, &path, 
				&shot_number, &sub_shot, &port, &timeout) ){
		return NULL;
	}

	int rtr_d = retrieveOpenDirectWait(diag, server, path, 
				shot_number, sub_shot, port, timeout);

	if( 0 > rtr_d ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","OpenDirectWait",  retrieveErrorMessage(rtr_d),  rtr_d);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	}
	PyObject* ret_val = Py_BuildValue("i", rtr_d);
	return ret_val;
}

/**
	[֐] close

	<>
		rtr_d :int	retrieveLqq

	<Ԓl>
       R[h :int		0=Success 0!=error 

	<O>
		TypeError
 */
static PyObject*
retrieve_close_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	if (!PyArg_ParseTuple(args,"i", &rtr_d)){
		return NULL;
	}

	int ret = retrieveClose(rtr_d);
	PyObject* ret_val = Py_BuildValue("i", ret);
	return ret_val;
}

/**
	[֐] shot_info

	<>
		rtr_d :int	retrieveLqq

	<Ԓl>
	@@^vz
@@@@@( n_channel, year, month, day, hour, sec,
          managemnet, comment, server )

	<O>
		TypeError,labcom._retrieve.Error
 */
static PyObject*
retrieve_shot_info_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	if (!PyArg_ParseTuple(args, "i", &rtr_d)){
		return NULL;
	}

	unsigned int n_channel;
	short year, month, day, hour, min, sec;
	char management[32];
	char comment[128];
	char server[64];
 
	int ret = retrieveShotInfo( rtr_d, &n_channel,
							   &year, &month, &day, &hour , &min , &sec,
							   management, comment, sizeof(comment), server); 
	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","ShotInfo", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	PyObject* ret_obj = Py_BuildValue("(i,h,h,h,h,h,h,s,s,s)",
		n_channel, year, month, day, hour , min , sec,
							   management, comment, server); 
	return ret_obj;
}
/**
	[֐] ch_info

	<>
		rtr_d :int						retrieveLqq
		ch_no :int					`lԍ
		| signal_name :String		 ܂͐M

	<Ԓl>
	@^vz
@@@@(ch_no, data_length, comp_length, param_count, data_type,
              image_type, value_len, is_nframe, management, comment); 

	<O>
		TypeError,labcom._retrieve.Error
 */

static PyObject*
retrieve_ch_info_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	PyObject* ch_obj;

	if (!PyArg_ParseTuple(args,"iO", &rtr_d,  &ch_obj)){
		return NULL;
	}

	int ch_no = 1;
	char* sig_name;
	int ret;
	char management[32];
	char comment[128];
	int64_t data_length, comp_length;
	unsigned short param_count;
	unsigned short value_len;
	short data_type;
	char image_type[16];
	int is_nframe;

	if( PyObject_IsInstance(ch_obj,  (PyObject*)&PyInt_Type) ) {
		ch_no = PyInt_AsLong(ch_obj);
		ret = retrieveChInfo_ex( rtr_d, ch_no,
				    &data_length, &comp_length, &param_count ,
				    &data_type, image_type, &value_len, &is_nframe,
								   management, comment, sizeof(comment) ); 
	}
	else if( PyObject_IsInstance(ch_obj, (PyObject*)&PyString_Type) ) {
		sig_name = PyString_AsString(ch_obj);
		ret = retrieveChInfo2_ex( rtr_d, sig_name,
				    &data_length, &comp_length, &param_count ,
				    &data_type, image_type, &value_len, &is_nframe,
								   management, comment, sizeof(comment), &ch_no ); 
	}
	else {
		PyErr_SetString(PyExc_TypeError, "The 2nd arg is channel_no(int) or signal_name(String).");
		return NULL;
	}


	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","ChInfo", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	// "(i,l,l,H,h,s,H,i,s,s)"
	PyObject* ret_obj = Py_BuildValue("(i,L,L,H,h,s,H,i,s,s)",
			    ch_no, data_length, comp_length, param_count, data_type,
	            image_type, value_len, is_nframe, management, comment); 

	return ret_obj;
}
/**
	[֐] ch_data

	<>
		rtr_d :int    retrieveLqq
		ch_no :int    `lԍ
		size :long long   f[^oCgTCY

	<Ԓl>
	@@oCif[^iString)

	<O>
		TypeError,labcom._retrieve.Error

@@Ԓlnumpy.fromstring(,, dtype=np.int16)ŔzɕϊApB

 */
static PyObject*
retrieve_ch_data_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	int ch_no = 1;
	int64_t data_size;

	// "iiI"
	if (!PyArg_ParseTuple(args,"iiL", &rtr_d, &ch_no, &data_size)){
		return NULL;
	}

	int64_t data_length;
	char *data = new char[data_size];
	int ret = retrieveChData_ex( rtr_d, ch_no, data, data_size, &data_length);

	if( 0 != ret ) {
		delete [] data; 
		PyObject* code_obj = Py_BuildValue("(s,s,i)","ChData", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	}
 
	PyObject* ret_obj = PyString_FromStringAndSize((const char*)data, data_length);
	delete [] data; 

	return ret_obj;
}
/**
	[֐] ch_param

	<>
		rtr_d :int    		retrieveLqq
		ch_no :int    	`lԍ
		param_no :int	p[^ԍ

	<Ԓl>
	@@IuWFNg
@@@@(param_name:param_value, param_name+'#PTYPE':param_typej

	<O>
		TypeError,labcom._retrieve.Error
 */
static PyObject*
retrieve_ch_param_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	int ch_no = 1;
	int param_no = 1;

	if (!PyArg_ParseTuple(args,"iii", &rtr_d, &ch_no, &param_no)){
		return NULL;
	}

	char param_name[64];
	char paramtype_name[64];
	char param_value[64];
	int param_type;
	int ret = retrieveChParam( rtr_d, ch_no, param_no,
			    param_name, param_value, &param_type);

	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","ChParam", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	strcpy( paramtype_name, param_name);
	strcat( paramtype_name, "#PTYPE");
	PyObject* value_obj=NULL;
	double tmp_dbl;
	switch( param_type )
	{
	case R_PARAM_TYPE_STRING:
		value_obj = PyString_FromString(param_value); 
		break;
	case R_PARAM_TYPE_BYTE:
	case R_PARAM_TYPE_SHORT:
	case R_PARAM_TYPE_INT:
		// value_obj = PyInt_FromString(param_value,NULL,0);
		value_obj = PyInt_FromLong(atoi(param_value)); 
		break;
	case R_PARAM_TYPE_FLOAT:
	case R_PARAM_TYPE_DOUBLE:
		tmp_dbl = atof(param_value);
		value_obj = PyFloat_FromDouble(tmp_dbl); 
		break;
	case R_PARAM_TYPE_INT64:
		value_obj = PyLong_FromString(param_value,NULL,0); 
		break;
	default:
		value_obj = PyString_FromString(param_value); 
		break;
	}
	//  ߂lDictɂ
	PyObject* ret_obj = Py_BuildValue("{s:O,s:i}", 
		param_name, value_obj, paramtype_name, param_type);
	Py_DECREF(value_obj);  
	return ret_obj;
}
/**
	[֐] ch_params

	<>
		rtr_d :int    	retrieveLqq
		ch_no :int    	`lԍ

	<Ԓl>
	@@IuWFNg
@@@@(param_name:param_value, param_name+'#PTYPE':param_typej

	<O>
		TypeError,labcom._retrieve.Error
 */
static PyObject*
retrieve_ch_params_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	int ch_no = 1;

	if (!PyArg_ParseTuple(args,"ii", &rtr_d, &ch_no )){
		return NULL;
	}

	char paramtype_name[64];
	char** key_tbl=NULL;
	char** val_tbl=NULL;
	int* type_tbl=NULL;
	
	int64_t data_length;
	int64_t comp_length;
	unsigned short param_count;
	short data_type;
	char image_type[32], management[128], comment[128];
	unsigned short value_len;
	int is_nframe;
	int comment_size=128;

	int ret=retrieveChInfo_ex( rtr_d, ch_no,
		&data_length, &comp_length, &param_count, &data_type, image_type, &value_len, &is_nframe,
					management ,comment ,comment_size );
	if( 0 !=ret ) {
		// SET EXCEPT
		PyObject* code_obj = Py_BuildValue("(s,s,i)","ChInfo", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	}

	if( 0 < param_count ) {
		key_tbl=new char *[param_count];
		val_tbl=new char *[param_count];
		type_tbl=new int[param_count];
		for(int j=0;j<param_count;j++)	{
			key_tbl[j]=new char[128];
			val_tbl[j]=new char[128];
		}
		ret =  retrieveChParams(rtr_d, ch_no, key_tbl, val_tbl, type_tbl );
		if( 0 != ret ) {
			for(int j=0;j<param_count;j++) {
				delete[] key_tbl[j];
				delete[] val_tbl[j];
			}
			delete[] key_tbl;
			delete[] val_tbl;
			delete[] type_tbl;
			// SET EXCEPT
			PyObject* code_obj = Py_BuildValue("(s,s,i)","ChParams", retrieveErrorMessage(ret), ret);
			PyErr_SetObject(RetrieveError, code_obj);
			Py_DECREF(code_obj);  
			return NULL;
		}
	}
	else {
		Py_INCREF(Py_None);
		return Py_None;
	}

	PyObject* ret_obj = PyDict_New();

	PyObject* value_obj=NULL;
	PyObject* type_obj=NULL;
	double tmp_dbl;
	for(int i=0;i< param_count;i++) {
		strcpy( paramtype_name, key_tbl[i]);
		strcat( paramtype_name, "#PTYPE");
		type_obj = PyInt_FromLong(type_tbl[i]); 
		switch( type_tbl[i] )
		{
			case R_PARAM_TYPE_STRING:
				value_obj = PyString_FromString(val_tbl[i]); 
				break;
			case R_PARAM_TYPE_BYTE:
			case R_PARAM_TYPE_SHORT:
			case R_PARAM_TYPE_INT:
				//value_obj = PyInt_FromString(val_tbl[i], NULL, 0); 
				value_obj = PyInt_FromLong(atoi(val_tbl[i])); 
				break;
			case R_PARAM_TYPE_FLOAT:
			case R_PARAM_TYPE_DOUBLE:
				tmp_dbl = atof(val_tbl[i]);
				value_obj = PyFloat_FromDouble(tmp_dbl); 
				break;
			case R_PARAM_TYPE_INT64:
				value_obj = PyLong_FromString(val_tbl[i], NULL, 0); 
				break;
			default:
				value_obj = PyString_FromString(val_tbl[i]); 
				break;
		}
		if( 0 != PyDict_SetItemString(ret_obj, key_tbl[i], value_obj) ) {
			Py_DECREF(value_obj);  
			PyDict_Clear(ret_obj);
			Py_DECREF(ret_obj);
			ret_obj = NULL;
			break;  
		}
		if( 0 != PyDict_SetItemString(ret_obj, paramtype_name, type_obj) ) {
			Py_DECREF(type_obj);  
			PyDict_Clear(ret_obj);
			Py_DECREF(ret_obj);  
			ret_obj = NULL;
			break;  
		}
	}
	for(int j=0;j<param_count;j++) {
		delete[] key_tbl[j];
		delete[] val_tbl[j];
	}
	delete[] key_tbl;
	delete[] val_tbl;
	delete[] type_tbl;
	return ret_obj;
}
/**

	[֐] frame_info

	<>
		rtr_d :int    	retrieveLqq
		ch_no :int    	`lԍ
		frame_no :int	t[ԍ

	<Ԓl>
	@@^vz
@@@@(byte_length, image_type, frame_x, frame_y); 

	<O>
		TypeError,labcom._retrieve.Error
 */

static PyObject*
retrieve_frame_info_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	int ch_no = 1;
	int frame_no;

	if (!PyArg_ParseTuple(args,"iii", &rtr_d, &ch_no, &frame_no)){
		return NULL;
	}

	int64_t byte_length;
	char image_type[16];
	int frame_x,frame_y;
	int ret = retrieveFrameInfo_ex( rtr_d, ch_no, frame_no,
			    &byte_length, image_type, &frame_x, &frame_y);

	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","FrameInfo", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 
	// "(I,s,I,I)"
	PyObject* ret_obj = Py_BuildValue("(L,s,I,I)", byte_length, image_type, frame_x, frame_y); 

	return ret_obj;
}

/**
	[֐] frame_data

	<>
		rtr_d :int    	retrieveLqq
		ch_no :int    	`lԍ
		frame_no :int	t[ԍ
		size :long long		f[^oCgTCY

	<Ԓl>
	@@oCif[^ :String

	<O>
		TypeError,labcom._retrieve.Error

@@Ԓlnumpy.fromstring(,, dtype=np.int16)ŔzɕϊApB

 */
static PyObject*
retrieve_frame_data_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	int ch_no = 1;
	int frame_no;
	int64_t data_size;

	// "iiiI"
	if (!PyArg_ParseTuple(args,"iiiL", &rtr_d, &ch_no, &frame_no, &data_size)){
		return NULL;
	}

	int64_t data_length;
	char *data = new char[data_size];
	int ret = retrieveFrameData_ex( rtr_d, ch_no, frame_no, data, data_size, &data_length);

	if( 0 != ret ) {
		delete [] data; 
		PyObject* code_obj = Py_BuildValue("(s,s,i)","FrameData", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	PyObject* ret_obj = PyString_FromStringAndSize((const char*)data, data_length);
	delete [] data; 

	return ret_obj;
}
/**
	[֐] time_info

	<>
		rtr_d :int						retrieveLqq
		ch_no :int					`lԍ

	<Ԓl>
	@^vz
@@@@(samplingcycle, triggetdelay, start0timing, time_array_size);

	<O>
		TypeError,labcom._retrieve.Error
 */
static PyObject*
retrieve_time_info_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	int ch_no = 1;

	if (!PyArg_ParseTuple(args,"ii", &rtr_d, &ch_no ) ){
		return NULL;
	}
	
	char dts_source[NAME_LEN], dts_hostid[NAME_LEN], dts_moduleid[NAME_LEN];
	char clk_source[NAME_LEN], clk_hostid[NAME_LEN], clk_moduleid[NAME_LEN];
	char dts_trig_channel[NAME_LEN], dts_clk_channel[NAME_LEN];
	int dts_user_define;
	char clk_ext_int[NAME_LEN];
	int64_t time_array_size;
	int64_t samplingcycle,triggerdelay,start0timing;
	int64_t begin_no, end_no;
	int ret;

	ret = retrieveTimeInfo( rtr_d, ch_no,
					dts_source, dts_hostid, dts_moduleid, dts_trig_channel,
					clk_source, clk_hostid, clk_moduleid, dts_clk_channel,
					&dts_user_define, clk_ext_int, &time_array_size,
					&samplingcycle, &triggerdelay, &start0timing,-1);

	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","TimeInfo", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	ret = retrieveGetRetrievePseudoNo( rtr_d, ch_no, &begin_no, &end_no);
	if( 0 != ret ) {
		begin_no =1;
	}
	start0timing += (begin_no -1) *samplingcycle;

	PyObject* ret_obj = Py_BuildValue("(L,L,L,L)", samplingcycle, triggerdelay, start0timing, time_array_size); 
	return ret_obj;
}

/**
	[֐] retrieve_no

	<>
		rtr_d :int						retrieveLqq
		ch_no :int					`lԍ

	<Ԓl>
	@^vz
@@@@(begin_no, end_no);

	<O>
		RetrieveError,TypeError
 */
static PyObject*
retrieve_retrieve_no_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	int ch_no = 1;

	if (!PyArg_ParseTuple(args,"ii", &rtr_d, &ch_no ) ){
		return NULL;
	}
	
	int64_t begin_no, end_no;
	int ret;

	ret = retrieveGetRetrieveNo( rtr_d, ch_no, &begin_no, &end_no);
	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","RetrieveNo", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	PyObject* ret_obj = Py_BuildValue("(L,L)", begin_no,end_no); 
	return ret_obj;
}
/**
	[֐] retrieve_pseudono

	<>
		rtr_d :int						retrieveLqq
		ch_no :int					`lԍ

	<Ԓl>
	@^vz
@@@@(begin_no, end_no);

	<O>
		TypeError,labcom._retrieve.Error
 */
static PyObject*
retrieve_retrieve_pseudono_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	int ch_no = 1;

	if (!PyArg_ParseTuple(args,"ii", &rtr_d, &ch_no ) ){
		return NULL;
	}
	
	int64_t begin_no, end_no;
	int ret;

	ret = retrieveGetRetrievePseudoNo( rtr_d, ch_no, &begin_no, &end_no);
	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","RetrievePseudoNo", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	PyObject* ret_obj = Py_BuildValue("(L,L)", begin_no,end_no); 
	return ret_obj;
}
/**
	[֐] ch_volts

	<>
		rtr_d :int    	retrieveLqq
		ch_no :int    	`lԍ
		size :long long		f[^TCY

	<Ԓl>
	@@4oCgfloat^oCif[^ :String

	<O>
		TypeError,labcom._retrieve.Error

@@Ԓlnumpy.fromstring(,, dtype=np.float32)ŔzɕϊApB

 */
static PyObject*
retrieve_ch_volts_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	int ch_no = 1;
	int64_t data_size;
	//"iiI"
	if (!PyArg_ParseTuple(args,"iiL", &rtr_d, &ch_no, &data_size)){
		return NULL;
	}

	int64_t data_length;
	float *data = new float[data_size];
	int ret = retrieveChVolts_ex( rtr_d, ch_no, data, data_size, &data_length);

	if( 0 != ret ) {
		delete [] data; 
		PyObject* code_obj = Py_BuildValue("(s,s,i)","ChVolts", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	PyObject* ret_obj = PyString_FromStringAndSize((const char*)data, data_length*sizeof(float));
	delete [] data; 

	return ret_obj;
}

/**
	[֐] ch_volts_dbl

	<>
		rtr_d :int    	retrieveLqq
		ch_no :int    	`lԍ
		size :uint		f[^TCY

	<Ԓl>
	@@8oCgfloat^oCif[^ :String

	<O>
		TypeError,labcom._retrieve.Error

@@Ԓlnumpy.fromstring(,, dtype=np.float64)ŔzɕϊApB

 */
static PyObject*
retrieve_ch_volts_dbl_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	int ch_no = 1;
	int64_t data_size;
	// "iiI"
	if (!PyArg_ParseTuple(args,"iiL", &rtr_d, &ch_no, &data_size) ){
		return NULL;
	}

	int64_t data_length;
	double *data = new double[data_size];
	int ret = retrieveChVoltsDbl_ex( rtr_d, ch_no, data, data_size, &data_length);

	if( 0 != ret ) {
		delete [] data; 
		PyObject* code_obj = Py_BuildValue("(s,s,i)","ChVoltsDbl", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	PyObject* ret_obj = PyString_FromStringAndSize((const char*)data, data_length*sizeof(double));
	delete [] data; 

	return ret_obj;
}
static int bytes_per_data( char* image_type, int value_len)
{
	if( NULL != image_type ) {
		// image_typeD悷B
		if(	0 == strncasecmp("INT",  image_type, 3 )   || 
				0 == strncasecmp("FLT",  image_type, 3 )   ){
			value_len = atoi(image_type+3) ;
		}
		else if(	0 == strncasecmp("GRAY", image_type, 4)  || 
		            	0 == strncasecmp("GREY", image_type, 4)    ){
			value_len = atoi(image_type+4) ;
		}
		else {
				// value_lenMB
		}
	}
	return( (value_len-1)/8 + 1);
}
/**
	[֐] bytes_per_data

	<>
		image_type :string    	C[W̌^
		value_len :uint		f[^rbgiPf[^\Ărbgj

	<Ԓl>
		bytes :int

	<O>
		TypeError

@@image_typeNULL̏ꍇȀꍇvalue_lenZoB

 */
static PyObject*
retrieve_bytes_per_data_py(PyObject* self, PyObject* args)
{
	char* image_type;
	int value_len;

	if (!PyArg_ParseTuple(args,"si",  &image_type, &value_len) ){
		return NULL;
	}
	int bytes = bytes_per_data( image_type,  value_len);

	PyObject* ret_obj = Py_BuildValue("i", bytes); 

	return ret_obj;
}
/**
	[֐] ch_v_synthesized_number

	<>
		rtr_d :int    retrieveLqq
		ch_no :int    `lԍ

	<Ԓl>
		num :int

	<O>
		TypeError,labcom._retrieve.Error

 */
static PyObject*
retrieve_ch_v_synthesized_number_py(PyObject* self, PyObject* args)
{
	int rtr_d;
	int ch_no = 1;

	if (!PyArg_ParseTuple(args,"ii", &rtr_d, &ch_no) ){
		return NULL;
	}

	int ret = retrieveChVsynthesizedNumber( rtr_d, ch_no);

	if( 0 > ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","ChVsynthesizedNumber", retrieveErrorMessage(ret), ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	}
 
	PyObject* ret_obj = Py_BuildValue("i", ret); 
	return ret_obj;
}

/**
	[֐] to_data_len

	<>
		byte_length :int    	f[^oCg
		image_type :string    	C[W̌^
		value_len :uint		f[^rbgiPf[^\Ărbgj

	<Ԓl>
	@@^vz
@@@@( data_len, image_type)

	<O>
		TypeError

@@image_typeNULL̏ꍇȀꍇvalue_lenZoB

 */
static PyObject*
retrieve_to_data_len_py(PyObject* self, PyObject* args)
{
	int64_t byte_length;
	char* image_type;
	int value_len;

	if (!PyArg_ParseTuple(args,"Lsi", &byte_length,  &image_type, &value_len) ){
		return NULL;
	}
	if( NULL == image_type || 0 == strlen(image_type ) ){
		if(           9 > value_len ) 	image_type = "INT8";
		else if( 17 > value_len )	image_type = "INT16";
		else if( 33 > value_len )	image_type = "INT32";
		else if( 65 > value_len )	image_type = "INT64";
	}
	int bytes = bytes_per_data( image_type,  value_len);
	int64_t data_len = byte_length/bytes;

	PyObject* ret_obj = Py_BuildValue("(L,s)", data_len, image_type); 

	return ret_obj;
}

/**
	[֐] dts_info_from_db
	<>
		diag_name :String    
		shot_number :uint
		sub_shot :short
		ch_number :short

	<Ԓl>
	@@^vz
@@@@( dts_source, dts_hostid, dts_moduleid, trig_channel, clk_channel,
              dts_user_define, clk_source, pre_samplings, samp_interval) 

	<O>
		TypeError,labcom._retrieve.Error
 */
static PyObject*
retrieve_dts_info_from_db_py(PyObject* self, PyObject* args)
{
	char* diag;
	unsigned int shot_number;
	short	sub_shot;
	short	ch_number;

	if (!PyArg_ParseTuple(args,"sIhh", &diag, &shot_number, &sub_shot, &ch_number)){
		return NULL;
	}

	char dts_source[NAME_LEN], dts_hostid[NAME_LEN], dts_moduleid[NAME_LEN];
	short trig_channel,clk_channel;
	int dts_user_define;
	int dmy_array_size;
	char clk_ext_int[NAME_LEN];
	int pre_samplings;
	int samp_interval;
	int dmy_clk_hostid;	
	char dmy_clk_moduleid[NAME_LEN];

	int ret = retrieveGetDTSinfox( 
				diag, shot_number, sub_shot, ch_number, ch_number, NULL,
				dts_source, dts_hostid, dts_moduleid, &trig_channel, &clk_channel,
				&dts_user_define, &dmy_array_size, clk_ext_int, &pre_samplings,
				&samp_interval, &dmy_clk_hostid, dmy_clk_moduleid);

	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","GetDTSinfox", "retrieve_t", ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	PyObject* ret_obj = Py_BuildValue("(s,s,s,h,h,i,s,i,i)",
				dts_source, dts_hostid, dts_moduleid, trig_channel, clk_channel,
				dts_user_define, clk_ext_int, pre_samplings, samp_interval);
	return ret_obj;
}
/**
	[֐] dts_info_from_retrieve

	<>
		rtr_d :int   
		ch_number :int
       | signal_name :String
		need_dts_link :int

	<Ԓl>
	@@^vz
@@@@( dts_source, dts_hostid, dts_moduleid, dts_trig_channel,
		  clk_source, clk_hostid, clk_moduleid, dts_clk_channel,
         dts_user_define, clk_source, internal_clk, 
         samp_interval, pre_samplings, last_count) 

	<O>
		TypeError,labcom._retrieve.Error

 */
static PyObject*
retrieve_dts_info_from_retrieve_py(PyObject* self, PyObject* args)
{
	int	rtr_d;
	PyObject* ch_obj;
	int need_dts_link;


	if (!PyArg_ParseTuple(args,"iOi", &rtr_d, &ch_obj, &need_dts_link)){
		return NULL;
	}

	int ch_type;
	int ch_no;
	void* ch_no_sig_name;
	if( PyObject_IsInstance(ch_obj, (PyObject*)&PyInt_Type) ) {
		ch_no = PyInt_AsLong(ch_obj);
		ch_type = sizeof( ch_no);
		ch_no_sig_name = &ch_no;
	}
	else if( PyObject_IsInstance(ch_obj, (PyObject*)&PyString_Type) ) {
		ch_type=0;
		ch_no_sig_name = PyString_AsString(ch_obj);
	}
	else {
		PyErr_SetString(PyExc_TypeError, "The 2nd arg is channel_no(int) or signal_name(String).");
		return NULL;
	}

	int dmy_ch_number;
	unsigned int dmy_shot;
	unsigned short dmy_sub_shot;
	char dts_source[NAME_LEN], dts_hostid[NAME_LEN], dts_moduleid[NAME_LEN];
	char clk_source[NAME_LEN], clk_hostid[NAME_LEN], clk_moduleid[NAME_LEN];
	char dts_trig_channel[NAME_LEN], dts_clk_channel[NAME_LEN];
	int dts_user_define;
	int64_t dmy_array_size;
	char clk_ext_int[NAME_LEN], internal_clock[NAME_LEN];
	char pre_samplings[NAME_LEN];
	char samp_interval[NAME_LEN];
	int64_t last_count;

	int ret = retrieveGetDTSinfoFromRetrieve_ex( 
					rtr_d, ch_type, ch_no_sig_name, need_dts_link, &dmy_ch_number, 
					&dmy_shot, &dmy_sub_shot,
					dts_source, dts_hostid, dts_moduleid, dts_trig_channel,
					clk_source, clk_hostid, clk_moduleid, dts_clk_channel,
					&dts_user_define, &dmy_array_size, clk_ext_int,
					internal_clock, samp_interval, pre_samplings, &last_count);

	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","GetDTSinfoFromRetrieve", "retrieve_t", ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	PyObject* ret_obj = Py_BuildValue("(s,s,s,s,s,s,s,s,i,s,s,s,s,L)",
					dts_source, dts_hostid, dts_moduleid, dts_trig_channel,
					clk_source, clk_hostid, clk_moduleid, dts_clk_channel,
					dts_user_define, clk_ext_int,
					internal_clock, samp_interval, pre_samplings, last_count);
	return ret_obj;
}

/**
	[֐] dts_data
	<>
		dts_source :String    
		dts_hostid :String    
		dts_moduleid :String    
		dts_trig_channel :String    
		clk_source :String    
		clk_hostod :String    
		clk_moduleid :String    
		dts_clk_channel :String
        dts_user_define :int
        time_array_size :int     
		shot_number :uint
		sub_shot :short
		clock_source :String        
		internal_clock :String        
		sampling_interval :String
		pre_sampling :String
		last_count :int64

	<Ԓl>
	@@^vz
@@@@( sampling_cycle, start_timing) 

	<O>
		TypeError,labcom._retrieve.Error
 */
static PyObject*
retrieve_dts_data_py(PyObject* self, PyObject* args)
{
	char *dts_source, *dts_host_id, *dts_moduleid, *dts_trig_channel;
	char *clk_source, *clk_host_id, *clk_moduleid, *dts_clk_channel;
	int  dts_user_define;
	int64_t time_array_size;
	char *clock_source, *internal_clock;
	char *sampling_interval, *pre_sampling;
	int64_t	last_count;
	unsigned int shot;
	unsigned short subshot;
	const short C_SILENT	= 1;
	const int C_DOUBLE	= 1;

	// "ssssssssiiIHssssL"
	if (!PyArg_ParseTuple(args,"ssssssssiLIHssssL",
		&dts_source, &dts_host_id, &dts_moduleid, &dts_trig_channel,
		&clk_source, &clk_host_id, &clk_moduleid, &dts_clk_channel,
		&dts_user_define, &time_array_size, &shot, &subshot,
		&clock_source, &internal_clock, &sampling_interval,  &pre_sampling,
		&last_count) ){
		return NULL;
	}

	double sampling_cycle, start_timing;
	// z͍쐬ȂB@ŴݎZoB
	int ret = retrieveGetDTSdatax2_ex( NULL,
			dts_source, dts_host_id, dts_moduleid, dts_trig_channel,
			clk_source, clk_host_id, clk_moduleid, dts_clk_channel,
			&dts_user_define, time_array_size,  shot, subshot,
			clock_source, internal_clock, sampling_interval,  pre_sampling, last_count,
			C_SILENT,C_DOUBLE, NULL, &sampling_cycle, &start_timing);

	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","GetDTSdatax2", "retrieve_t", ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	PyObject* ret_obj = Py_BuildValue("(d,d)",  sampling_cycle, start_timing);
	return ret_obj;
}
/**
	[֐] rgb_from_yuv422

	<>
		data :PyString				YUV422f[^(UYVY)
		blen :int    	              f[^oCgTCY
		model:int    	              fi1:scA64070gc, !1:Otherj

	<Ԓl>
	@@oCif[^ :String

	<O>
		TypeError,labcom._retrieve.Error

@@Ԓlnumpy.fromstring(,, dtype=np.uint8)ŔzɕϊApB

 */
static PyObject*
retrieve_rgb_from_yuv422_py(PyObject* self, PyObject* args)
{
	int blen;
	int model;
	PyObject* data_obj;

	if ( !PyArg_ParseTuple(args,"Oii", &data_obj, &blen, &model) ){
		return NULL;
	}
	unsigned char* yuv_data = NULL;
	unsigned int yuv_data_len = 0;
	if( Py_None == data_obj ) {
		return PyString_FromStringAndSize(NULL, 0);
	}
	else {
		if( PyString_Check(data_obj) ) {
			yuv_data = (unsigned char*)PyString_AsString(data_obj);
			yuv_data_len = PyString_Size(data_obj);
		}
		else {
			PyObject* code_obj = Py_BuildValue("(s,s)","RGBfromYUV422", "DATA should be String." );
			PyErr_SetObject(RetrieveError, code_obj);
			Py_DECREF(code_obj);
			return NULL;
		}
	}
	if( (unsigned int)blen > yuv_data_len) blen=yuv_data_len;
	int rgb_blen=0;
	if( 1 > blen ) {
		return PyString_FromStringAndSize(NULL, 0);
	}
	unsigned char *rgb_data = new unsigned char[blen/2*3];
	rgb_blen = RGBfromYUV422( rgb_data, yuv_data, blen, model);

	PyObject* ret_obj = PyString_FromStringAndSize((const char*)rgb_data, rgb_blen);
	delete [] rgb_data;

	return ret_obj;
}
/**
	[֐] rgb_from_yuy2

	<>
		data :PyString				YUY2f[^(YUYV)
		blen :int    	              f[^oCgTCY

	<Ԓl>
	@@oCif[^ :String

	<O>
		TypeError,labcom._retrieve.Error

@@Ԓlnumpy.fromstring(,, dtype=np.uint8)ŔzɕϊApB

 */
static PyObject*
retrieve_rgb_from_yuy2_py(PyObject* self, PyObject* args)
{
	int blen;
	PyObject* data_obj;

	if ( !PyArg_ParseTuple(args,"Oi", &data_obj, &blen) ){
		return NULL;
	}
	unsigned char* yuv_data = NULL;
	unsigned int yuv_data_len = 0;
	if( Py_None == data_obj ) {
		return PyString_FromStringAndSize(NULL, 0);
	}
	else {
		if( PyString_Check(data_obj) ) {
			yuv_data = (unsigned char*)PyString_AsString(data_obj);
			yuv_data_len = PyString_Size(data_obj);
		}
		else {
			PyObject* code_obj = Py_BuildValue("(s,s)","RGBfromYUV422", "DATA should be String." );
			PyErr_SetObject(RetrieveError, code_obj);
			Py_DECREF(code_obj);
			return NULL;
		}
	}
	if( (unsigned int)blen > yuv_data_len) blen=yuv_data_len;
	int rgb_blen=0;
	if( 1 > blen ) {
		return PyString_FromStringAndSize(NULL, 0);
	}
	unsigned char *rgb_data = new unsigned char[blen/2*3];
	rgb_blen = RGBfromYUY2( rgb_data, yuv_data, blen);

	PyObject* ret_obj = PyString_FromStringAndSize((const char*)rgb_data, rgb_blen);
	delete [] rgb_data;

	return ret_obj;
}

static PyMethodDef retrieve_methods[] = {
  {"open",			retrieve_open_py,			METH_VARARGS},
  {"open_direct",	retrieve_open_direct_py,	METH_VARARGS},
  {"open_range",	retrieve_open_range_py,	METH_VARARGS},
  {"close",			retrieve_close_py,			METH_VARARGS},
  {"shot_info",		retrieve_shot_info_py,		METH_VARARGS},
  {"ch_info",		retrieve_ch_info_py,		METH_VARARGS},
  {"ch_data",		retrieve_ch_data_py,		METH_VARARGS},
  {"ch_param",		retrieve_ch_param_py,	METH_VARARGS},
  {"ch_params",		retrieve_ch_params_py,	METH_VARARGS},
  {"frame_info",		retrieve_frame_info_py,	METH_VARARGS},
  {"frame_data",		retrieve_frame_data_py,	METH_VARARGS},
  {"ch_volts",  			retrieve_ch_volts_py,	   	METH_VARARGS},
  {"ch_volts_dbl",	retrieve_ch_volts_dbl_py,METH_VARARGS},
  {"to_data_len",		retrieve_to_data_len_py, METH_VARARGS},
  {"bytes_per_data",retrieve_bytes_per_data_py, METH_VARARGS},
  {"ch_v_synthesized_number",retrieve_ch_v_synthesized_number_py, METH_VARARGS},

  {"dts_info_from_db",		retrieve_dts_info_from_db_py,		METH_VARARGS},
  {"dts_info_from_retrieve",retrieve_dts_info_from_retrieve_py,	METH_VARARGS},
  {"dts_data",						retrieve_dts_data_py,						METH_VARARGS},

  {"time_info",					retrieve_time_info_py,					METH_VARARGS},
  {"retrieve_no",				retrieve_retrieve_no_py,				METH_VARARGS},
  {"retrieve_pseudono",	retrieve_retrieve_pseudono_py,	METH_VARARGS},
  {"rgb_from_yuv422",       retrieve_rgb_from_yuv422_py,    METH_VARARGS},
  {"rgb_from_yuy2",         retrieve_rgb_from_yuy2_py,      METH_VARARGS},
/* version 19.0.0 delete 2015-10-01
  {"dts_info_from_params",	retrieve_dts_info_from_params_py,	METH_VARARGS},
  {"dts_data_from_params",retrieve_dts_data_from_params_py,METH_VARARGS},
*/
  {"version",		retrieve_version_py,			METH_NOARGS},
  {NULL},
};

void init_retrieve() 
{
  //  import_array();
  PyObject *m,*d;
  
  m = Py_InitModule("labcom._retrieve", retrieve_methods);
  d = PyModule_GetDict(m);
  RetrieveError = Py_BuildValue("s", "labcom._retrieve.Error");
  PyDict_SetItemString(d,"error", RetrieveError);
}
/**
	[֐] dts_info_from_params

	<>
		parameters :Dict
		need_dts_link :int

	<Ԓl>
	@@^vz
@@@@( dts_source, dts_hostid, dts_moduleid, dts_trig_channel,
		  clk_source, clk_hostid, clk_moduleid, dts_clk_channel,
         dts_user_define, clk_source, internal_clk, 
         samp_interval, pre_samplings, last_count) 

 */
/* delete 2015-10-01
static PyObject*
retrieve_dts_info_from_params_py(PyObject* self, PyObject* args)
{
	PyObject* params_obj;
	int need_dts_link;
	if (!PyArg_ParseTuple(args,"Oi", &params_obj, &need_dts_link)){
		return NULL;
	}

	char** keys_tbl =NULL;
	char** vals_tbl =NULL;
	int params_cnt = 0;
	if( PyObject_IsInstance(params_obj, (PyObject*)&PyDict_Type) ) {
	// params_obj->> keys,vals
		int p_cnt = PyDict_Size(params_obj);
		if( 1 > p_cnt ) {
			PyObject* code_obj = Py_BuildValue("(s,s,i)","GetDTSinfoFromRarameters",
				 "Parameters is free.", 0);
			PyErr_SetObject(RetrieveError, code_obj);
			Py_DECREF(code_obj);  
			return NULL;
		}

		keys_tbl = new char*[p_cnt];
		vals_tbl = new char*[p_cnt];
		PyObject *key, *val;
		PyObject *val_str_obj;
		char *key_str, *val_str, *val_str_p;
//		int pos=0;
		Py_ssize_t pos=0;
		while( PyDict_Next(params_obj, &pos, &key, &val) ) {
			key_str = PyString_AsString(key);
			if( NULL !=  strstr(key_str, "#PTYPE") ) continue;
			val_str_obj = PyObject_Str(val);
			val_str = PyString_AsString(val_str_obj);
			keys_tbl[params_cnt] = key_str;
			val_str_p = new char[strlen(val_str)+1];
			strcpy(val_str_p, val_str);
			vals_tbl[params_cnt] = val_str_p;
			Py_DECREF(val_str_obj);
			params_cnt++;	
		}
	}
	else {
		PyErr_SetString(PyExc_TypeError, "The 1st arg must Dict.");
		return NULL;
	}

	unsigned int dmy_shot;
	unsigned short dmy_sub_shot;
	char dts_source[NAME_LEN], dts_hostid[NAME_LEN], dts_moduleid[NAME_LEN];
	char clk_source[32], clk_hostid[NAME_LEN], clk_moduleid[NAME_LEN];
	char dts_trig_channel[NAME_LEN], dts_clk_channel[NAME_LEN];
	int dts_user_define;
	int dmy_array_size;
	char clk_ext_int[NAME_LEN];
	char pre_samplings[NAME_LEN];
	char samp_interval[NAME_LEN];
	char internal_clock[NAME_LEN];
	int64_t last_count;

	int ret = GetDTSinfoFromChParameters( 
					params_cnt, keys_tbl, vals_tbl, need_dts_link, 
					&dmy_shot, &dmy_sub_shot,
					dts_source, dts_hostid, dts_moduleid, dts_trig_channel,
					clk_source, clk_hostid, clk_moduleid, dts_clk_channel,
					&dts_user_define, &dmy_array_size, clk_ext_int,
					internal_clock, samp_interval, pre_samplings, &last_count);

	for(int i=0; i < params_cnt; i++) {
		delete [] vals_tbl[i];
	}
	delete [] vals_tbl;
	delete [] keys_tbl;
	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","GetDTSinfoFromRarameters", "retrieve_t", ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	PyObject* ret_obj = Py_BuildValue("(s,s,s,s,s,s,s,s,i,s,s,s,s,L)",
					dts_source, dts_hostid, dts_moduleid, dts_trig_channel,
					clk_source, clk_hostid, clk_moduleid, dts_clk_channel,
					dts_user_define, clk_ext_int,
					internal_clock, samp_interval, pre_samplings, last_count);
	return ret_obj;
}
*/
/**
	[֐] dts_data_from_params
	<>
		diag :String    
		shot_number :uint    
		sub_shot :ushort    
		channel :short   
		parameter :Dict    

	<Ԓl>
	@@^vz
@@@@( sampling_cycle, start_timing) 

	<O>
		TypeError,labcom._retrieve.Error
 */
/* delete 2015-10-01
static PyObject*
retrieve_dts_data_from_params_py(PyObject* self, PyObject* args)
{
	char* diag;
	unsigned int shot_number;
	unsigned short	sub_shot;
	short	ch_number;
	PyObject* params_obj;

	if (!PyArg_ParseTuple(args,"sIhhO",&diag, &shot_number, &sub_shot, &ch_number, &params_obj)){
		return NULL;
	}
	int need_dts_link;
	char** keys_tbl =NULL;
	char** vals_tbl =NULL;
	int params_cnt = 0;
	char dts_source[NAME_LEN], dts_hostid[NAME_LEN], dts_moduleid[NAME_LEN];
	char clk_source[NAME_LEN], clk_hostid[NAME_LEN], clk_moduleid[NAME_LEN];
	char dts_trig_channel[NAME_LEN], dts_clk_channel[NAME_LEN];

	short trig_channel,clk_channel;
	int dts_user_define;
	int dmy_array_size;
	char clk_ext_int[NAME_LEN];
	int dmy_pre_samplings;
	int dmy_samp_interval;
	int dmy_clk_hostid;	
	char dmy_clk_moduleid[NAME_LEN];

	need_dts_link = 1;
	if( 56221 > shot_number ) {
		int ret = retrieveGetDTSinfox( 
				diag, shot_number, sub_shot, ch_number, ch_number, NULL,
				dts_source, dts_hostid, dts_moduleid, &trig_channel, &clk_channel,
				&dts_user_define, &dmy_array_size, clk_ext_int, &dmy_pre_samplings,
				&dmy_samp_interval, &dmy_clk_hostid, dmy_clk_moduleid);

		if( 0 != ret ) {
			PyObject* code_obj = Py_BuildValue("(s,s,i)","GetDTSinfox", "retrieve_t", ret);
			PyErr_SetObject(RetrieveError, code_obj);
			Py_DECREF(code_obj);  
			return NULL;
		} 
  		need_dts_link = 0;
		strcpy(clk_source, dts_source);
		strcpy(clk_hostid, dts_hostid);
		strcpy(clk_moduleid, dts_moduleid);
		sprintf(dts_trig_channel, "%d", trig_channel);
		sprintf(dts_clk_channel, "%d", clk_channel);
	}

	if( PyObject_IsInstance(params_obj, (PyObject*)&PyDict_Type) ) {
		// params_obj->> keys,vals
		int p_cnt = PyDict_Size(params_obj);
		if( 1 > p_cnt ) {
			PyObject* code_obj = Py_BuildValue("(s,s,i)","GetDTSinfoFromRarameters",
				 "Parameters is free.", 0);
			PyErr_SetObject(RetrieveError, code_obj);
			Py_DECREF(code_obj);  
			return NULL;
		}

		keys_tbl = new char*[p_cnt];
		vals_tbl = new char*[p_cnt];
 		PyObject *key, *val;
 		PyObject *val_str_obj;
		char *key_str, *val_str, *val_str_p;
//		int pos=0;
		Py_ssize_t pos=0;
		while( PyDict_Next(params_obj, &pos, &key, &val) ) {
			key_str = PyString_AsString(key);
			if( NULL !=  strstr(key_str, "#PTYPE") ) continue;
			val_str_obj = PyObject_Str(val);
			val_str = PyString_AsString(val_str_obj);
			keys_tbl[params_cnt] = key_str;
			val_str_p = new char[strlen(val_str)+1];
			strcpy(val_str_p, val_str);
			vals_tbl[params_cnt] = val_str_p;
			Py_DECREF(val_str_obj);
			params_cnt++;	
		}
	}
	else {
		PyErr_SetString(PyExc_TypeError, "The last arg must Dict.");
		return NULL;
	}

	unsigned int dmy_shot;
	unsigned short dmy_sub_shot;
	char pre_samplings[NAME_LEN];
	char samp_interval[NAME_LEN];
	char internal_clock[NAME_LEN];
	int64_t last_count;
	const short C_SILENT	= 1;
	const int C_DOUBLE	= 1;

	int ret = GetDTSinfoFromChParameters( 
					params_cnt, keys_tbl, vals_tbl, need_dts_link, 
					&dmy_shot, &dmy_sub_shot,
					dts_source, dts_hostid, dts_moduleid, dts_trig_channel,
					clk_source, clk_hostid, clk_moduleid, dts_clk_channel,
					&dts_user_define, &dmy_array_size, clk_ext_int,
					internal_clock, samp_interval, pre_samplings, &last_count);

	for(int i=0; i < params_cnt; i++) {
		delete [] vals_tbl[i];
	}
	delete [] vals_tbl;
	delete [] keys_tbl;
	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","GetDTSinfoFromRarameters", "retrieve_t", ret);
		PyErr_SetObject(RetrieveError, code_obj);
		Py_DECREF(code_obj);  
		return NULL;
	} 

	double  sampling_cycle=0.0 , start_timing=0.0;

	ret = retrieveGetDTSdatax2( NULL,
				dts_source, dts_hostid, dts_moduleid, dts_trig_channel,
				clk_source, clk_hostid, clk_moduleid, dts_clk_channel,
				&dts_user_define, dmy_array_size,  shot_number, sub_shot,
	    		clk_ext_int, internal_clock, samp_interval,  pre_samplings, last_count,
				C_SILENT,C_DOUBLE, NULL, &sampling_cycle, &start_timing);

	if( 0 != ret ) {
		PyObject* code_obj = Py_BuildValue("(s,s,i)","GetDTSdatax2", "retrieve_t", ret);
 		PyErr_SetObject(RetrieveError, code_obj);
 		Py_DECREF(code_obj);  
		return NULL;
	} 

	PyObject* ret_obj = Py_BuildValue("(d,d)",  sampling_cycle, start_timing);
	return ret_obj;

}
*/
