#include <octave/oct.h>
#include "retrieve-oct.h"

DEFUN_DLD (mRetrieveClose, args, nargout,
"Close process for retrieve-Protocol.\n"
" \n"
"  code = mRetrieveClose( rtd, verbose)\n"
           )
{
  const int MIN_IN_ARG = 1;
  const int MAX_IN_ARG = 2;
  const int MAX_OUT_ARG = 1;
  const std::string funcn = "mRetrieveClose";
  
  bool opt_verbose = false;
  int rtd = 0;
  int nargin = args.length();
  
  int code = 0;
  for( ;; ) {
    // check 0.nargin
    if( nargin < MIN_IN_ARG || nargin > MAX_IN_ARG) {
      code = OCT_IF_ERR_ARG_NUM_INPUT_ARG;
      break;
    }
    // check 0. nargout
    if( nargout > MAX_OUT_ARG) {
      code = OCT_IF_ERR_ARG_NUM_OUTPUT_ARG;
      break;
    }
    // check 1.rtd
    if( 0 != (code=get_arg_int( args(0), rtd )) )  {
      code += OCT_IF_ERR_ARG1;  break;
    }
    if( retrieve_debug ) octave_stdout << funcn <<" rtd:" << rtd << "\n";
    if( nargin > 1 ) {
      // check 2.verbose
      if( 0 != (code=get_arg_bool( args(1), opt_verbose )) )  {
        code += OCT_IF_ERR_ARG2;  break;
      }
    }
    if( retrieve_debug ) octave_stdout << funcn <<" verbose:" << opt_verbose << "\n";
    break;
  }
  if( 0 == code )  {
    code = octave_retrieve_close(rtd);    // with IndexNoClosing();
  }
  if( 0 != code && opt_verbose ) octave_retrieve_error_message( code, funcn);
  return(octave_value(code));
}
