#ifndef _OCT_IF_H_
#define _OCT_IF_H_

#include "oct_if_error.h"

#if OCTAVE_MAJOR_VERSION > 3
#define  INT64_VALUE_DEFINED  
#endif

#if !defined(INT16_MAX)
#define INT16_MAX SHRT_MAX
#endif

#if !defined(UINT16_MAX)
#define UINT16_MAX USHRT_MAX
#endif

typedef struct {
  int paramCounts;
  char** paramItem;
  char** paramVal;
  int*   paramType;
} PARAMS_BASE;

int get_arg_int( const octave_value& arg, int& val);
int get_arg_uint( const octave_value& arg, unsigned int& val);
int get_arg_short( const octave_value& arg, short& val);
int get_arg_ushort( const octave_value& arg, unsigned short& val);
int get_arg_int64( const octave_value& arg, int64_t& val);
int get_arg_string( const octave_value& arg, std::string& val);
int get_arg_bool( const octave_value& arg, bool& val);

int params_from_octave(const octave_map& params, PARAMS_BASE& base);
void params_base_initial( PARAMS_BASE& base );
void params_base_free( PARAMS_BASE& base );
int octave2param_type( const octave_value& val);
char* octave2param_string( const octave_value& val);

#define OPTION_STR_SIZE	128
#define DIAG_NAME_SIZE	128
#define RTR_HOST_SIZE	128
#define RTR_PATH_SIZE	128
#define RTR_RANGE_SIZE	128
#define RTR_MANAGE_SIZE	128
#define RTR_COMMENT_SIZE	256
#define RTR_SERVER_SIZE	128
#define RTR_SIGNAL_NAME_SIZE 64
#define RTR_IMAGE_TYPE_SIZE 32
#define RTR_DATA_CLASS_SIZE 32

#define DTS_SOURCE_SIZE 32
#define DTS_HOSTID_SIZE 32
#define DTS_MODULEID_SIZE 32
#define DTS_CH_NAME_SIZE 32
#define RTR_CLK_SOURCE_SIZE 32
#define RTR_INTERNAL_CLOCK_SIZE 32
#define RTR_SAMP_INTERVAL_SIZE 32
#define RTR_PRE_SMAPLES_SIZE 32

#define PNAME_MAX_LEN	128
#define PVALUE_MAX_LEN	128

#endif