#include <octave/oct.h>
#include "retrieve.h"

bool retrieve_debug = false;

//------------------------------------------------------------------------------
int octave_retrieve_close( int rtd )
{
    int code = retrieveClose(rtd);
    IndexNoClosing(0);
    return(code);
}
const char* cImageType2DataClass(const char* image_type, int& bytes)
{
  const char* class_name="";
  if( 0 == strcmp(image_type, "INT8") ) {
        bytes = 1;        class_name="int8";
  }
  else if( 0 == strcmp(image_type, "INT16") ) {
        bytes = 2;        class_name="int16";
  }
  else if( 0 == strcmp(image_type, "INT32") ) {
        bytes = 4;        class_name="int32";
  }
  else if( 0 == strcmp(image_type, "INT64") ) {
        bytes = 8;        class_name="int64";
  }
  else if( 0 == strcmp(image_type, "FLT32") ) {
        bytes = 4;        class_name="single";
  }
  else if( 0 == strcmp(image_type, "FLT64") ) {
        bytes = 8;        class_name="double";
  }
  else if( 0 == strcmp(image_type, "YUV422") ) {
        bytes = 2;        class_name="uint16";
  }
  else if( 0 == strcmp(image_type, "YUY2") ) {
        bytes = 2;        class_name="uint16";
  }
  else if( 0 == strcmp(image_type, "BayerBG8") ) {
        bytes = 1;        class_name="uint8";
  }
  else if( 0 == strcmp(image_type, "BayerBG16") ) {
        bytes = 2;        class_name="uint16";
  }
  else {
    int value_len = 0;
    if( 0 == strncmp(image_type,"GRAY",4 ) || 0 == strncmp(image_type,"GREY",4 ) ) {
      value_len = atoi(image_type+4);
    }
    else {
      if( 4 == strlen(image_type) ||  3 == strlen(image_type) ) {
        if( NULL != strchr(image_type,'R') &&
            NULL != strchr(image_type,'G') &&
            NULL != strchr(image_type,'B')    ) {
              value_len = 32;
         }
       }
    }
    if( value_len < 9 ) {
        bytes = 1;  class_name = "uint8";
    }
    else if( value_len < 17 ) {
        bytes = 2;  class_name = "uint16";
    }
    else if( value_len < 33 ) {
        bytes = 4;  class_name = "uint32";
    }
    else {
        bytes = 8;  class_name = "int64";
    }
  }
  return class_name;
}
int cClassName2bytesize( const char*class_name )
{
  int bytes = 1;
  if( 0 == strcmp(class_name, "int8") ||
      0 == strcmp(class_name, "uint8") ) {
    bytes = 1;
  }
  else if( 0 == strcmp(class_name, "int16") ||
           0 == strcmp(class_name, "uint16") ) {
    bytes = 2;
  }
  else if( 0 == strcmp(class_name, "int32") ||
           0 == strcmp(class_name, "uint32")||
           0 == strcmp(class_name, "single") ) {
    bytes = 4;
  }
  else if( 0 == strcmp(class_name, "int64") ||
           0 == strcmp(class_name, "uint64")||
           0 == strcmp(class_name, "double") ) {
    bytes = 8;
  }
  return bytes;
}
